; write backup of given file to medium
; written for DATAdesign engine v3.+
; (c)30/12/1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_keys_err
*
; BACKup of file to a medium
; writes entire file (all records)
; parameters: same as SAVI
; errors: any errors from SAVI, FRST, NEXT, SAVR, SAVF, NEWR
cod_BACK xsub
        regsave d7/a4
p.id    equ     4       ; place with bufferid

s.iid   equ     0       ; old default indexid
s.view  equ     4       ; old value for b_view
s.len   equ     6
        getssp  s.len

        move.l  p.id(a1),d0     ; buffer id if passed
        tst.w   p.id-4(a1)      ; is the buffer id given ?
        bne.s   ibuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
ibuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        xjsr    cod_newr        ; clear buffer
        bne.s   codend

        move.b  b_view(a4),s.view(sp)   ; save view status
        move.l  b_dindex(a4),s.iid(sp)  ;      default index
        clr.l   b_index(a4)     ; no default index
        move.b  #1,b_view(a4)   ; view only file

        xjsr    cod_savi        ; init save sequence
        bne.s   stop
        xjsr    cod_frst        ; take first record
        bne.s   close
loop    xjsr    cod_savr        ; save record
        bne.s   close
        xjsr    cod_next        ; next record
        beq.s   loop
        cmpi.l  #err.itnf,d0    ; end of file reached
        bne.s   close
        moveq   #0,d0           ; no error
close   move.l  d0,d7           ; keep error
        xjsr    cod_savf        ; end save sequence
        move.l  d7,d0           ; restore error
stop    move.b  s.view(sp),b_view(a4)   ; restore view status
        move.l  s.iid(sp),b_dindex(a4)  ;         default index
codend  subend
;
        end
