; duplicate a record, make sure not overwritten when implementing
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_keys_err
*
; duplicate a record, make sure not overwritten when implementing
; when the record hasn't changed before implemnting, than it won't be implemnted either
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
; errors
; itnf  buffer id invalid
cod_DUPL xsub
        regsave d1/a1/a3/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        tst.b   b_new(a4)       ; was this a new record ?
        bne.s   clear           ; yes -> ok
        ; now clear the edited status of the record
        mutex
        move.l  b_id(a4),d1     ; recordid
        move.l  b_file(a4),a3   ; fileid
        xjsr    findrec         ; find record
        clr.b   rl_edit(a1)     ; not edited any more
        endmutex

clear   move.b  #1,b_new(a4)    ; we are editing a new record
        moveq   #0,d0           ; everything ok
codend
        subend
;
        end
