; index remove
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include flp1_engine_aid_mac
        include flp1_engine_struct_h
*
; index remove
; parameters
p.id    equ     $4      ; buffer id or indexid (long word, optional)
; errors
; itnf  buffer or indexid not found
cod_IRMV xsub
        regsave d1-d7/a0-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        move.l  d0,a2           ; or it can be the indexid
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   tindex          ; if not -> try it as an index
        move.l  b_dindex(a4),a2 ; take default index
tindex  move.l  a2,d0
        beq.s   codend          ; no index -> nothing to do
        xjsr    testiid         ; see if it is valid
        bne.s   codend
        move.l  i_buffer(a2),a4 ; then this is the buffer id
        move.l  b_file(a4),a3   ; we need the fileid

        ; unlink it
        lea     b_index(a4),a1
        xjsr    unlink          ; unlink a2 from list in a1

        ; and release it
        rellist i_area(a2)
        move.l  a2,a0
        xjsr    relmem
codend
        subend
;
        end
