* routines which form the DATAdesign mutex semaphore (well, almost)
* written by Joachim Van der Auwera
* for PROGS, PROfessional & Graphical Software
* (c) 3 October 1993
        section text
        include win1_dd_src_engine_aid_mac
        include win1_inc_qdos_sms
        include win1_inc_keys_thg
        include win1_inc_keys_err
*
fc_copy dc.b    '1.00'
        xdef fc_mutex
fc_mutex dc.w   16,'DATAdesign mutex'

; routine to start a mutually exclusive part
mutex   xsub
        regsave d0-d7/a0-a5
        xjsr    thg_fthg        ;find thing thing
        move.l  8(a3),a3        ;TH_ENTRY
        moveq   #0,d2           ;extension
        lea     fc_mutex(pc),a0 ;name of thing to use
        moveq   #sms.myjb,d1    ;myself
        moveq   #sms.uthg,d0    ;Use Thing
        jsr     (a3)
oops    subend

; routine to end a mutually exclusive part
endmutex xsub
        regsave d0-d7/a0-a5
        jsr     thg_fthg(pc)    ; find thing thing
        move.l  8(a3),a3        ; TH_ENTRY
        lea     fc_mutex(pc),a0 ; name of thing to use
        moveq   #sms.myjb,d1    ; myself
        moveq   #sms.fthg,d0    ; Free Thing
        jsr     (a3)
        subend


; routine to initialise DATAdesign mutex thing
        xdef    mutexini
mutexini xsub
        regsave d1-d7/a0-a5
        xjsr    thg_fthg        ;find THING-thing
        move.l  8(a3),a4        ;ptr to th_entry
        lea     fc_mutex(pc),a0 ;name of thing to remove
        moveq   #sms.rthg,d0    ;Remove Thing from list
        jsr     (a4)
        cmpi.w  #err.fdiu,d0    ; if thing in use
        beq.s   ok              ; -> don't overwrite

        move.l  #22+$2a,d1      ; thing linkage length
        xjsr    getmem          ; allocate & clear
        tst.l   d0
        bne.s   kill

        move.b  #-1,th_nshar(a0); mutex thing NOT SHAREABLE !!
        moveq   #10,d0          ; nr of words to copy
        lea     fc_copy(pc),a1
        lea     th_verid(a0),a2
nam_cpy move.w  (a1)+,(a2)+
        dbf     d0,nam_cpy      ; copy name of thing

        lea     thg_head(pc),a2
        move.l  a2,th_thing(a0) ; pointer to thing

        move.l  a0,a1           ; address of thing linkage
        moveq   #sms.lthg,d0    ; Link in new Thing
        jsr     (a4)            ; (th_entry)

ok      moveq   #0,d0           ; prepare for Basic
kill    subend

thg_head
        dc.l    thh.flag        ; flag signalling standard header
        dc.l    $00000002       ; type of thing
        dc.l    0,0,0,0         ; next, extra ID, params desciption
        rts
;
        end
