; get the date (time) the record was last implemented
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_keys_err
*
; get the date (time) the record was last implemented
; returns 0 if the recorded wasn't implemented just yet
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.ret   equ     $c      ; return value (ulong)
; errors
; itnf  buffer id invalid
; any file i/o error
cod_DATE xsub
        regsave d1/d2/a1/a3/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        move.l  b_file(a4),a3
        move.l  p.ret(a5),a1    ; place to fill in return value
        tst.b   b_new(a4)       ; was this a new record ?
        bne.s   codend          ; yes -> done

        move.l  b_id(a4),d1     ; find the record
        xjsr    findrec
        bne.s   codend          ; oops

        tst.b   f_file(a3)
        beq.s   memdate

        mutex
        move.l  f_chid(a3),a0   ; channel id
        move.l  rl_pos(a1),d1   ; start of record
        addq.l  #6,d1           ; skip other data
        xjsr    iof_posa        ; position file
        bne.s   ahum

        ; read date in d2
        moveq   #0,d2           ; clear record len
        xjsr    iob_fbyt
        bne.s   ahum
        move.b  d1,d2
        xjsr    iob_fbyt
        bne.s   ahum
        lsl.l   #8,d2
        move.b  d1,d2
        xjsr    iob_fbyt
        bne.s   ahum
        lsl.l   #8,d2
        move.b  d1,d2
        xjsr    iob_fbyt
        bne.s   ahum
        lsl.l   #8,d2
        move.b  d1,d2

        move.l  p.ret(a5),a1
        move.l  d2,(a1)

ahum    endmutex
        bra.s   codend
memdate
        move.l  rl_pos(a1),a3   ; start of record
        move.l  p.ret(a5),a1
        move.l  r_date(a3),(a1)
codend
        subend
;
        end
